<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 3/13/17
 * Time: 9:29 PM
 */

namespace qfq;

use TYPO3\CMS\Core\FormProtection\Exception;

require_once(__DIR__ . '/../store/Sip.php');
//require_once(__DIR__ . '/store/FillStoreForm.php');
require_once(__DIR__ . '/../store/Session.php');
require_once(__DIR__ . '/../Constants.php');
//require_once(__DIR__ . '/Save.php');
//require_once(__DIR__ . '/helper/KeyValueStringParser.php');
require_once(__DIR__ . '/../helper/Ldap.php');
//require_once(__DIR__ . '/helper/HelperFormElement.php');
//require_once(__DIR__ . '/exceptions/UserFormException.php');
//require_once(__DIR__ . '/exceptions/CodeException.php');
//require_once(__DIR__ . '/exceptions/DbException.php');
//require_once(__DIR__ . '/exceptions/ErrorHandler.php');
require_once(__DIR__ . '/../Database.php');
//require_once(__DIR__ . '/Evaluate.php');
//require_once(__DIR__ . '/BuildFormPlain.php');
//require_once(__DIR__ . '/BuildFormTable.php');
//require_once(__DIR__ . '/BuildFormBootstrap.php');
//require_once(__DIR__ . '/report/Report.php');
//require_once(__DIR__ . '/BodytextParser.php');
//require_once(__DIR__ . '/Delete.php');
//require_once(__DIR__ . '/form/FormAction.php');


class TypeAhead {

    /**
     * @var Database instantiated class
     */
    protected $db = null;

    /**
     * @var array
     */
    protected $vars = array();

    /**
     *
     */
    public function __construct($phpUnit = false) {

        if (!isset($_GET[TYPEAHEAD_API_QUERY]) || !isset($_GET[TYPEAHEAD_API_SIP])) {
            throw new CodeException('Missing GET parameter "' . TYPEAHEAD_API_SIP . '" or "' . TYPEAHEAD_API_QUERY . '"');
        }

        $this->vars[TYPEAHEAD_API_QUERY] = $_GET[TYPEAHEAD_API_QUERY];
        $this->vars[TYPEAHEAD_API_SIP] = $_GET[TYPEAHEAD_API_SIP];

        $session = Session::getInstance($phpUnit);

        $this->db = new Database();

    }

    /**
     * @return array|int
     * @throws CodeException
     * @throws DbException
     * @throws UserFormException
     */
    public function process() {

        $arr = array();
        $values = array();

        $sipClass = new Sip();

        $sipVars = $sipClass->getVarsFromSip($this->vars[TYPEAHEAD_API_SIP]);

        if (isset($sipVars[FE_TYPEAHEAD_SQL])) {
            $arr = $this->typeAheadSql($sipVars, $this->vars[TYPEAHEAD_API_QUERY]);
        } elseif (isset($sipVars[FE_LDAP_SERVER])) {
            $ldap = new Ldap();
            $arr = $ldap->process($sipVars, $this->vars[TYPEAHEAD_API_QUERY]);
        }

        return $arr;
    }

    /**
     * @param array $config
     * @param $query
     * @return array|int
     * @throws CodeException
     * @throws DbException
     */
    private function typeAheadSql(array $config, $query) {
        $values = array();

        $query = '%' . $query . '%';
        $cnt = substr_count($config[FE_TYPEAHEAD_SQL], '?');
        for ($ii = 0; $ii < $cnt; $ii++) {
            $values[] = $query;
        }

        return $this->db->sql($config[FE_TYPEAHEAD_SQL], ROW_REGULAR, $values);
    }

}